Index: /GTP/trunk/App/Demos/Geom/Demo_LodManager/Ogre.log
===================================================================
--- /GTP/trunk/App/Demos/Geom/Demo_LodManager/Ogre.log	(revision 1804)
+++ /GTP/trunk/App/Demos/Geom/Demo_LodManager/Ogre.log	(revision 1804)
@@ -0,0 +1,39 @@
+19:09:00: Creating resource group General
+19:09:00: Registering ResourceManager for type Material
+19:09:00: Registering ResourceManager for type Mesh
+19:09:00: Registering ResourceManager for type Skeleton
+19:09:00: Loading library OgrePlatform_d.dll
+19:09:00: OverlayElementFactory for type Panel registered.
+19:09:00: OverlayElementFactory for type BorderPanel registered.
+19:09:00: OverlayElementFactory for type TextArea registered.
+19:09:00: Registering ResourceManager for type Font
+19:09:00: ArchiveFactory for archive type FileSystem registered.
+19:09:00: ArchiveFactory for archive type Zip registered.
+19:09:00: DevIL version: Developer's Image Library (DevIL) 1.6.7 Oct 28 2005
+19:09:00: DevIL image formats: bmp dib cut dcx dds gif hdr ico cur jpg jpe jpeg lif mdl mng jng pcx pic pix png pbm pgm pnm ppm psd pdd psp pxr sgi bw rgb rgba tga vda icb vst tif tiff wal xpm raw 
+19:09:00: Registering ResourceManager for type HighLevelGpuProgram
+19:09:00: An exception has been thrown!
+
+-----------------------------------
+Details:
+-----------------------------------
+Error #: 8
+Function: ConfigFile::load
+Description: 'plugins.cfg' file not found!. 
+File: c:\softwaredevelopment\c++\ogresdk\ogrenew_vc71\ogremain\src\ogreconfigfile.cpp
+Line: 79
+Stack unwinding: <<beginning of stack>>
+19:09:00: plugins.cfg not found, automatic plugin loading disabled.
+19:09:00: *-*-* OGRE Initialising
+19:09:00: *-*-* Version 1.0.6 (Azathoth)
+19:09:00: An exception has been thrown!
+
+-----------------------------------
+Details:
+-----------------------------------
+Error #: 8
+Function: ConfigFile::load
+Description: 'resources.cfg' file not found!. 
+File: c:\softwaredevelopment\c++\ogresdk\ogrenew_vc71\ogremain\src\ogreconfigfile.cpp
+Line: 79
+Stack unwinding: <<beginning of stack>>
Index: P/trunk/App/Demos/Geom/Ogre.log
===================================================================
--- /GTP/trunk/App/Demos/Geom/Ogre.log	(revision 1791)
+++ 	(revision )
@@ -1,39 +1,0 @@
-19:09:00: Creating resource group General
-19:09:00: Registering ResourceManager for type Material
-19:09:00: Registering ResourceManager for type Mesh
-19:09:00: Registering ResourceManager for type Skeleton
-19:09:00: Loading library OgrePlatform_d.dll
-19:09:00: OverlayElementFactory for type Panel registered.
-19:09:00: OverlayElementFactory for type BorderPanel registered.
-19:09:00: OverlayElementFactory for type TextArea registered.
-19:09:00: Registering ResourceManager for type Font
-19:09:00: ArchiveFactory for archive type FileSystem registered.
-19:09:00: ArchiveFactory for archive type Zip registered.
-19:09:00: DevIL version: Developer's Image Library (DevIL) 1.6.7 Oct 28 2005
-19:09:00: DevIL image formats: bmp dib cut dcx dds gif hdr ico cur jpg jpe jpeg lif mdl mng jng pcx pic pix png pbm pgm pnm ppm psd pdd psp pxr sgi bw rgb rgba tga vda icb vst tif tiff wal xpm raw 
-19:09:00: Registering ResourceManager for type HighLevelGpuProgram
-19:09:00: An exception has been thrown!
-
------------------------------------
-Details:
------------------------------------
-Error #: 8
-Function: ConfigFile::load
-Description: 'plugins.cfg' file not found!. 
-File: c:\softwaredevelopment\c++\ogresdk\ogrenew_vc71\ogremain\src\ogreconfigfile.cpp
-Line: 79
-Stack unwinding: <<beginning of stack>>
-19:09:00: plugins.cfg not found, automatic plugin loading disabled.
-19:09:00: *-*-* OGRE Initialising
-19:09:00: *-*-* Version 1.0.6 (Azathoth)
-19:09:00: An exception has been thrown!
-
------------------------------------
-Details:
------------------------------------
-Error #: 8
-Function: ConfigFile::load
-Description: 'resources.cfg' file not found!. 
-File: c:\softwaredevelopment\c++\ogresdk\ogrenew_vc71\ogremain\src\ogreconfigfile.cpp
-Line: 79
-Stack unwinding: <<beginning of stack>>